unit multimag;
{ ACHTUNG: il y a une temporisation dans l'envoi des commandes au multimag !!!!!! }
{ le seul fait que la temporisation existe suffit (1s est suffisant ?! }
{ unit de pilotage du multimag sur le port serie RS232 }
{ format des commandes: BEGIN+COMMAND
{ les commandes disponibles sont:
{ }
{ Acos donne de toute facon une valeur entre 0 et Pi !!! }
{ question, les deux champs donns par les deux cylindres sont-ils egaux??? }
{ NE PAS OUBLIER DE FAIRE flushBuffer avant tout envoi de commande sur le port serie }
{ c'est curieux qu'il n'y ait qu'une seule valeur de Bmax?!?                         }
{ VITESSE:  50 ca bourre bien                                                       }
{           24-25 est une vitesse plus raisonnable                                   }
{           15 c'est bien, pas trop ni trop rapide                                   }
{ N.B. la vitesse se perd au ifl du temps; il faut la reloader?!?                    }
{ Pilotage en sens de rotation des moteurs                                           }
{ pour tourner theta en positif => 'AC'                                              }
{ avec 'CC' il va sytmatiquement dans le mauvais sens ?!                              }
{ MAIS il arrive toujours au but!         }
{ ecrire duex procdures de telle sorte qu'on ne puisse pas changer le champ ET l'angle en meme temps }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TeEngine, Series, ExtCtrls, TeeProcs, Chart, EditReal, Comrs232,
  Spin,math;

const
     BEGINcomm=chr(02); { debut d'une chaine de commande pour le multimag }
     ENDcomm=chr(03);   { fin d'une chaine de commande pour le multiamg }
     deltaB=1; { mT, limite de precision que l'on s'impose sur le champ}
     deltaA=1; { , limite de prcision sur l'angle }
     temporisation=1;
     verySlowSpeed=4;
     SlowSpeed=8;
     NormalSpeed=15;

type
  TMRpanel = class(TForm)
    InitMultiMagButton: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    SWEEP: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    STOP: TButton;
    Label4: TLabel;
    Status: TEdit;
    connection: TEdit;
    Label5: TLabel;
    Label7: TLabel;
    Panel6: TPanel;
    Label11: TLabel;
    SetField: TButton;
    Label13: TLabel;
    Label14: TLabel;
    Panel7: TPanel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    SweepAng: TButton;
    StopAng: TButton;
    Label16: TLabel;
    Label20: TLabel;
    Bmax: TEditReal;
    NrSteps: TEditReal;
    B: TEditReal;
    NbrAcq: TEditReal;
    Angle: TEditReal;
    Bang: TEditReal;
    NbrStepsAng: TEditReal;
    Theta: TEditReal;
    NbrAcqAngle: TEditReal;
    Bset: TEditReal;
    AngleSet: TEditReal;
    CommPortDriver1: TCommPortDriver;
    Panel3: TPanel;
    Label6: TLabel;
    Label8: TLabel;
    OUTER_OFFSET: TSpinEdit;
    INNER_OFFSET: TSpinEdit;
    Label9: TLabel;
    FIELD_MAX: TSpinEdit;
    Label10: TLabel;
    SendButton: TButton;
    SendString: TEdit;
    ReceivedStrings: TMemo;
    FieldValueBox: TEditReal;
    Button1: TButton;
    ReadPosButton: TButton;
    SetSpeedButton: TButton;
    SetPosButton: TButton;
    ReadFieldButton: TButton;
    F2encod: TButton;
    Encod2Fbutton: TButton;
    TimerFollowField: TTimer;
    StopButton: TButton;
    Panel4: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Button2: TButton;
    DureePause: TEditReal;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure InitMultiMag;
    procedure InitMultiMagButtonClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure ReadFieldButtonClick(Sender: TObject);
    procedure SetFieldClick(Sender: TObject);
    procedure BsetChange(Sender: TObject);
    procedure AngleSetChange(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ReadPosButtonClick(Sender: TObject);
    procedure SetSpeedButtonClick(Sender: TObject);
    procedure SetPosButtonClick(Sender: TObject);
    procedure F2encodClick(Sender: TObject);
    procedure Encod2FbuttonClick(Sender: TObject);
    procedure TimerFollowFieldTimer(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FTempInBuffer: pointer; { pointeur sur le buffer d'entre du port srie }
    procedure CommPortDriver1ReceiveData(Sender: TObject;s:string;
      DataSize: Integer);
    procedure SendOnlyToMultimag(su:string);
    function SendToMultimag(su:string):string;
    procedure FieldToEncoder(B,angle:double;var encod1,encod2:integer); { test ok dans les quatre quadrants, avec champ positif uniquement }
    procedure EncoderToField(encod1,encod2:integer;var B,angle:double);  { test ok dans les quatre quadrants }
    { Private declarations }
  public
    { Public declarations }
    procedure SetDisplay_MultiMag(value:real;units:string); { presque ok, petits prblmes de temps en temps }
    procedure SetSpeed_multiMag(speedOUT,speedIN:integer); { effet non test }
    procedure GetPosition_MultiMag(var encodOUT,encodIN:integer); {ok}
    procedure SetPosition_MultiMag(speedOUT,speedIN:integer); { chaine ok, reponse multimag inconnue }
    procedure Stop_MultiMag(motor:string); { non test } { fonctionne pas quand on est en mode P !!! }
    procedure Run_MultiMag(mode,outerDir,innerDir,motor:string); { non test }
    procedure ReadField_MultiMag(var B,angle:double); {ok }
    procedure SetField_MultiMag(B,angle:double); { ok }
  end;

var
  MRpanel: TMRpanel;
  xtc:boolean; { quoi qu'est-ce? }
  FieldSetPoint,AngleSetPoint:double;

implementation

{$R *.DFM}

{ hrsie, mais je ne sais pas m'en sortir autrement (pour le moment) }
{ INPUT: temps = duree de la pause (en ms)   }
procedure pause(temps:double);
var u:double;
begin
     temps:=temps/100000000*60/52; { petit facteur de correction?!}
     u:=time;
     while u+temps>time do;
end;


{ initialisation de la connection et verification si l'ITC4 est allum }
{ PROBLEME: le programme ne passe pas par cette procdure           ???}
procedure TMRPanel.FormCreate(Sender: TObject);
begin
  xtc:=true;
  GetMem( FTempInBuffer,10);
  commportdriver1.connect;
  commportdriver1.FlushBuffers(true,true);
end;

procedure TMRPanel.FormDestroy(Sender: TObject);
begin
  commportdriver1.Disconnect;
  FreeMem( FTempInBuffer,10);
end;

{ pourquoi faut-il redefinir cette procedure ici ??? }
procedure TMRPanel.CommPortDriver1ReceiveData(Sender: TObject;
  s:string; DataSize: Integer);
var
s1:string[2];
begin
s1:=copy(s,length(s),1);
s:=copy(s,1,length(s)-1);
if s1=#6 then s:=s+' :ack';
if s1=#21 then s:=s+' :nack';
ReceivedStrings.lines.add(s);
end;

{ envoi d'une chaine au multimag }
{ INPUT: commande                }
{ OUTPUT: on ne lit pas la chaine recue }
{ Cette procdure est indispensable au cas ou le multiMag ne rpond rien !}
procedure TMRPanel.SendOnlyToMultimag(su:string);
var
u:integer;
p:pchar;
s1:string[1];
s:string;
u1,u2:double;
fin:boolean;
begin
  s:=su;
  pause(dureePause.value);
  commportdriver1.FlushBuffers(true,true);
  commportdriver1.SendData(pchar(s),length(s));
end;

{ envoi d'une chaine au multimag }
{ INPUT: commande                }
{ OUTPUT: chaine recue           }
function TMRPanel.SendToMultimag(su:string):string;
var
u:integer;
p:pchar;
s1:string[1];
s:string;
u1,u2:double;
fin:boolean;
begin
  s:=su;
  pause(dureePause.value);
  commportdriver1.FlushBuffers(true,true);
  commportdriver1.SendData( pchar(s),length(s));
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0001 est le timeout }
  while (u1+0.0001>time) and (s1[1]<>#3) do
  begin
    u:=_hread(commportdriver1.comhandle,@Ftempinbuffer^,1);
    if u>0 then
        begin
          p:=Ftempinbuffer;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then result:=s else result:='timeout';
end;

procedure TMRPanel.InitMultimag;
begin
  xtc:=true;
  GetMem( FTempInBuffer,50); { quelle est la taille optimale du buffer ?}
  commportdriver1.connect;
  commportdriver1.FlushBuffers(true,true);
  SetSpeed_multiMag(NormalSpeed,NormalSpeed); { vitesse normale }
end;

{ calcul de la position des encodeurs en fonction du champ et de l'angle demand }
{ INPUT: B en millitesla, angle en degrs                                        }
{ OUTPUT: encod1 et encod2: la position des deux encodeurs                       }
{ ACHTUNG, les test paraissent fumeux!!!!}
procedure TMRPanel.FieldToEncoder(B,angle:double;var encod1,encod2:integer);
var A1,A2:double;
begin
     angle:=angle*pi/180;
     A1:=arccos(B/FIELD_MAX.value)+angle;
     if A1<0 then A1:=A1+2*pi;
     if A1>=(2*pi) then A1:=A1-2*pi;
     A2:=-arccos(B/FIELD_MAX.value)+angle;
     if A2<0 then A2:=A2+2*pi;
     if A2>=(2*pi) then A2:=A2-2*pi;
     encod1:=round((4096-A1*4096/(2*Pi)+OUTER_OFFSET.value)) mod 4096;
     encod2:=round((A2*4096/(2*Pi)+INNER_OFFSET.value)) mod 4096;
end;

{ calcul du champ et de l'angle en fonction de la postion des deux encodeurs de  }
{ INPUT: encod1 et encod2: la position des deux encodeurs                       }
{ OUTPUT: B en millitesla, angle en degrs                                        }
{ ACHTUNG, les test paraissent fumeux!!!!}
procedure TMRPanel.EncoderToField(encod1,encod2:integer;var B,angle:double);
var A1,A2:double;
    Bx,By:double; { composantes du champ }
begin
     A1:=((4096+OUTER_OFFSET.value-encod1) mod 4096)*2*Pi/4096;
     A2:=((encod2-INNER_OFFSET.value) mod 4096)*2*Pi/4096;
     if A1>(2*pi) then A1:=A1-2*pi; { a priori inutile si le "mod" fonctionne correctment }
     if A2>(2*pi) then A2:=A2-2*pi;
     { somme des deux vecteurs (Bmax,A1) + (Bmax+A2) }
     Bx:=0.5*FIELD_MAX.value*(cos(A1)+cos(A2)); { bizarre qu'on ait un seul FIELD_MAX }
     By:=0.5*FIELD_MAX.value*(sin(A1)+sin(A2));
     { passage en coordonnes polaires }
     B:=sqrt(Bx*Bx+By*By);
     if Bx<>0 then
     begin
          if Bx>0 then angle:=arctan(By/Bx)*180/pi; {attention aux exceptions }
          if Bx<0 then begin angle:=arctan(By/Bx)*180/pi;angle:=angle+180; end;
          if angle<0 then angle:=angle+360;
     end
     else
     begin
          if By>=0 then angle:=90;
          if By<=0 then angle:=270;
          if By=0 then angle:=9999; { indtermination de la direction du champ }
     end;
     { ACHTUNG!!! }
     { a ce point, B est toujours positif }
     { il faut comparer l'angle demand avec le nouvel angle pour savoir si
     le champ est positif ou negatif }
end;

{ ================================== }
{ commandes du multimag              }
{ ================================== }

{ procdure d'affichage du champ }
{ INPUT: la valeur numrique du champ, l'unit sous la forme d'une string 'T' ou 'mT' ou 'G' ou 'kG' }
{ OUTPUT: affichage sur le boitier du multimag, c'est tout }
procedure TMRPanel.SetDisplay_MultiMag(value:real;units:string);
var s,s1:string;
    checksum:char;
    valueaux:real;
begin
     valueaux:=value;
     value:=abs(value);
     s:=#2+'FPD'; { begin + commande "display"}
     { formatage de l'unit }
     if units='mT' then begin str(value:4:0,s1);s:=s+'20' end;
     if units='T' then begin str(value:5:3,s1);s:=s+'10' end;
     if units='G' then begin str(value:4:0,s1);s:=s+'08' end;
     if units='kG' then begin str(value:5:2,s1);s:=s+'04' end;
     { signe du champ }
     if valueaux>=0 then s:=s+'+' else s:=s+'-';
     { valeur du champ, en abs }
     s:=s+'0'+s1;
     { terminateurs }
     s:=s+#3+'h';         { on s'en fout de la checksum ....!!!! }
     ReceivedStrings.lines.add(s);
     SendOnlyToMultimag(s);
end;

{ dfinition des vitesses des deux moteurs }
{ INPUT: les vitesses des deux moteurs speedOUT et speedIN; valeurs comprise entre 0 et FFh !!!}
{ OUTPUT: nant  }
{ REM: les valeurs par dfaut semblent tre 18h }
{ N.B.: il ne faut que les valeurs des vitesses dpassent FF en hexa }
procedure TMRPanel.SetSpeed_multiMag(speedOUT,speedIN:integer);
var s,s1,s2:string;
    checksum:char;
    valueaux:real;
begin
     if speedOUT>15 then fmtstr(s1,'%x',[speedOUT]) else begin fmtstr(s1,'%x',[speedOUT]);s1:='0'+s1 end;
     if speedIN>15 then fmtstr(s2,'%x',[speedIN]) else begin fmtstr(s2,'%x',[speedIN]);s2:='0'+s2 end;
     ReceivedStrings.lines.add(s1);
     ReceivedStrings.lines.add(s2);
     s:=#2+'W4'+s1+'00'+s2+'00'+#3+'b'; { on s'en fout de la checksum ....!!!! }
     ReceivedStrings.lines.add(s);
     SendOnlyToMultimag(s);
end;

{ procdure de lecture de la position des deux aimants  }
{ INPUT: none }
{ OUTPUT: la valeur des deux encodeurs encodOUT et encodIN }
procedure TMRPanel.GetPosition_MultiMag(var encodOUT,encodIN:integer);
var s,s1,s2,s3,s4:string;
    errorcode:integer;
    value:integer;
begin
     s:=SendToMultiMag(#2+'FGP'+#3+'P');
     ReceivedStrings.lines.add(s);
     { conversion de la chane en positions !!! }
     s1:=copy(s,2,2); { LOW BYTE EncodOUT }
     s2:=copy(s,4,2); { High BYTE EncodOUT }
     s3:=copy(s,6,2); { LOW BYTE EncodIN }
     s4:=copy(s,8,2); { High BYTE EncodIN }
     s1:='$'+s2+s1; { valeurs en hexa }
     s3:='$'+s4+s3;
     ReceivedStrings.lines.add(s1);
     ReceivedStrings.lines.add(s3);
     val(s1,encodOUT,errorcode);
     val(s3,encodIN,errorcode);
end;

{ procdure de dfinition des nouvelles positions  }
{ INPUT: EncodOUT et encodIN, les deux positions des encodeurs }
{ OUTPUT: les multimag est prt a se rendre  ces positions }
procedure TMRPanel.SetPosition_MultiMag(speedOUT,speedIN:integer);
var s,s1,s2,s3,s4,sOUT,sIN:string;
    errorcode:integer;
    value:integer;
    buf1,buf2:Pchar;
begin
     { je m'en sort pas avec les formats de strings }
     { => bidouille pour forcer  avoir des zros au debut de la chane}
     speedOUT:=speedOUT+$10000;speedIN:=speedIN+$10000;
     fmtstr(sOUT,'%5.0x',[speedOUT]);
     fmtstr(sIN,'%5.0x',[speedIN]);
     { conversion de la chane en positions, on se dbarasse de $10000 par la meme occasion }
     s1:=copy(sOUT,4,2); { LOW BYTE EncodOUT }
     s2:=copy(sOUT,2,2); { High BYTE EncodOUT }
     s3:=copy(sIN,4,2); { LOW BYTE EncodIN }
     s4:=copy(sIN,2,2); { High BYTE EncodIN }
     s:=#2+'W0'+s1+s2+s3+s4+#3+'b'; { on s'en fout de la checksum ....!!!! }
     ReceivedStrings.lines.add(s);
     SendOnlyToMultimag(s);
end;

{ procdure de stop des moteurs  }
{ INPUT: les moteurs que l'on souhaite arreter 'IN', 'OUT' or 'BOTH' }
{ OUTPUT: arrt du moteur correspondant }
procedure TMRPanel.Stop_MultiMag(motor:string);
var s,s1:string;
    checksum:char;
begin
     motor:=uppercase(motor);
     if motor='OUT' then s:=#2+'FS1'+#3+'V';
     if motor='IN' then s:=#2+'FS2'+#3+'V';
     if motor='BOTH' then s:=#2+'FSB'+#3+'V';
     ReceivedStrings.lines.add(s);
{    SendOnlyToMultimag(s); }
end;

{ procdure de run des moteurs  }
{ INPUT: mode: 'P' = go to the position; 'S' tourne jusqu' que multimag recoive STOP }
{        outerdir: 'A'= anticlockwise, 'C' = clockwise                                }
{        innerdir: idem                                                               }
{        motor: les moteurs que l'on souhaite bouger 'IN', 'OUT' or 'BOTH' }
{ OUTPUT: ca fait ce que ca peut }
procedure TMRPanel.Run_MultiMag(mode,outerDir,innerDir,motor:string);
var s,s1:string;
    checksum:char;
begin
     motor:=uppercase(motor);
     if motor='OUT' then s:=#2+'FR'+mode+outerdir+innerdir+'1'+#3+'h';
     if motor='IN' then s:=#2+'FR'+mode+outerdir+innerdir+'2'+#3+'h';
     if motor='BOTH' then s:=#2+'FR'+mode+outerdir+innerdir+'B'+#3+'h';
     ReceivedStrings.lines.add(s);
     SendOnlyToMultimag(s);
end;

{ lecture du champ  partir de la position des encodeurs }
{ IN: nothing                                            }
{ OUT: le champ (en T) et l'angle du champ (en )        }
procedure TMRPanel.ReadField_MultiMag(var B,angle:double);
var encodOUT,encodIN:integer;
begin
     GetPosition_MultiMag(encodOUT,encodIN);
     EncoderToField(encodOUT,encodIN,B,angle);
end;

{ lecture du champ  partir de la position des encodeurs }
{ IN: B (en T) et angle (en )                           }
{ OUT: le multimag se met  la position demande         }
procedure TMRPanel.SetField_MultiMag(B,angle:double);
var encodOUT,encodIN:integer;
    u1:double;
    Bcurr,thetaCurr:double; { valeurs de depart du champ et de l'angel }
begin
     ReadField_MultiMag(Bcurr,thetaCurr);
     FieldToEncoder(B,angle,encodOUT,encodIN);
     SetPosition_MultiMag(encodOUT,encodIN);
     { on dmarre le multimag en mode P }
     If B>=Bcurr then Run_MultiMag('P','C','C','BOTH');
     If B<Bcurr then Run_MultiMag('P','A','A','BOTH'); { il arrive toujours pile poil au but }
     { lecture de la position atteinte }
end;

{ ======================================================================= }

procedure TMRpanel.NextClick(Sender: TObject);
var caMarche:boolean;
begin
    SendToMultiMag('Next');
end;

procedure TMRpanel.InitMultiMagButtonClick(Sender: TObject);
begin
    initMultimag;
end;

procedure TMRpanel.StopClick(Sender: TObject);
begin
     { deactivate the sweep timer }
{     NextStep.enabled:=false;
     SendToMultimag('Stop');
     TimerStatus.enabled:=true; }
end;

procedure TMRpanel.ReadFieldButtonClick(Sender: TObject);
var B,theta:double;
begin
     ReadField_MultiMag(B,theta);
     Bset.value:=B;
     AngleSet.value:=theta
end;

procedure TMRpanel.SetFieldClick(Sender: TObject);
var s,S1,S2:string;
begin
     FieldSetPoint:=BSet.value;AngleSetPoint:=AngleSet.value;
     SetField_MultiMag(Bset.value,AngleSet.value);
{     SetField.enabled:=false; }
     TimerFollowField.enabled:=true; { affichage du champ pendant qu'il bouge }
end;

procedure TMRpanel.BsetChange(Sender: TObject);
begin
     SetField.enabled:=true;
end;

procedure TMRpanel.AngleSetChange(Sender: TObject);
begin
     SetField.enabled:=true;
end;

{ tests divers }

procedure TMRpanel.SendButtonClick(Sender: TObject);
var i:integer;
    s,s1:string;
begin
     commportdriver1.FlushBuffers(true,true); { indispensable }
     s:=#2+SendString.text+#3+'h';
     s1:=SendToMultiMag(s);
     ReceivedStrings.lines.add(s1);
end;

procedure TMRpanel.Button1Click(Sender: TObject);
begin
     SetDisplay_Multimag(FieldValueBox.value,sendString.text);
end;

procedure TMRpanel.SetSpeedButtonClick(Sender: TObject);
var speedOUT,speedIN:integer;
begin
     speedOUT:=round(FieldValueBox.value);
     speedIN:=speedOUT;
     SetSpeed_multiMag(speedOUT,speedIN);
end;

procedure TMRpanel.SetPosButtonClick(Sender: TObject);
begin
     SetPosition_Multimag(2047,1479);
end;

procedure TMRpanel.ReadPosButtonClick(Sender: TObject);
var encodIN,encodOUT:integer;
begin
     GetPosition_Multimag(encodOUT,encodIN);
     Bset.value:=encodOUT;
     AngleSet.value:=encodIN;
end;

procedure TMRpanel.F2encodClick(Sender: TObject); {ok}
var encodOUT,encodIN:integer;
    s:string;
begin
     FieldToEncoder(Bset.value,angleset.value,encodOUT,encodIN);
     Str(encodOUT,s);ReceivedStrings.lines.add(s);
     Str(encodIN,s);ReceivedStrings.lines.add(s);
end;

procedure TMRpanel.Encod2FbuttonClick(Sender: TObject); {ok}
var encodOUT,encodIN:double;
    s:string;
begin
     EncoderToField(round(Bset.value),round(angleset.value),encodOUT,encodIN);
     Str(encodOUT:4:0,s);ReceivedStrings.lines.add(s);
     Str(encodIN:4:0,s);ReceivedStrings.lines.add(s);
end;

procedure TMRpanel.TimerFollowFieldTimer(Sender: TObject);
var B,theta:double;
begin
     ReadField_MultiMag(B,theta);
     Bset.value:=B;
     AngleSet.value:=theta;
     SetDisplay_MultiMag(B/1000,'T');
     if (abs(B-FieldSetPoint)<deltaB) and (abs(theta-AngleSetPoint)<deltaA)
     then begin TimerFollowField.enabled:=false;SetField.enabled:=false end;


end;

procedure TMRpanel.StopButtonClick(Sender: TObject);
begin
     TimerFollowField.enabled:=false;
{     Stop_MultiMag('BOTH'); { fonctionne pas }
end;

procedure TMRpanel.Button2Click(Sender: TObject);
begin
     pause(Dureepause.value);
end;

end.


