unit PilotageIPS12010;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ips12010,
  StdCtrls, EditReal, GPIB_CEC, ComCtrls;

const
     add = 25; { adresse par dfaut de l'amimentation IPS12010 }

type
  TIPS12010form = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ReadFieldButton: TButton;
    SetFieldButton: TButton;
    field: TEditReal;
    Label3: TLabel;
    SweeprateButton: TButton;
    sweepRate: TEditReal;
    Label2: TLabel;
    Status: TLabel;
    GetStatusButton: TButton;
    InitButton: TButton;
    SendButton: TButton;
    SendString: TEdit;
    Label1: TLabel;
    reply: TEdit;
    HeaterOnButton: TButton;
    HeaterOffButton: TButton;
    procedure InitButtonClick(Sender: TObject);
    procedure HeaterOnButtonClick(Sender: TObject);
    procedure HeaterOffButtonClick(Sender: TObject);
    procedure SetFieldButtonClick(Sender: TObject);
    procedure GetStatusButtonClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure ReadFieldButtonClick(Sender: TObject);
    procedure pauseClick(Sender: TObject);
    procedure SweeprateButtonClick(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  IPS12010form: TIPS12010form;

implementation

{$R *.DFM}

procedure TIPS12010form.InitButtonClick(Sender: TObject);
begin
   Initialize_IPS12010(add);
end;

procedure TIPS12010form.HeaterOnButtonClick(Sender: TObject);
begin
     HeaterOn_IPS12010(add);
end;

procedure TIPS12010form.HeaterOffButtonClick(Sender: TObject);
begin
     HeaterOff_IPS12010(add);
end;

procedure TIPS12010form.SetFieldButtonClick(Sender: TObject);
begin
    status.caption:='Energizing';
    SetField_IPS12010(add,field.value);
    status.caption:='Persistent';
end;

procedure TIPS12010form.GetStatusButtonClick(Sender: TObject);
begin
     reply.text:=ExamineStatus_IPS12010(add);
end;

procedure TIPS12010form.SendButtonClick(Sender: TObject);
begin
     reply.text:=Send_IPS12010(add,sendString.text);
end;

procedure TIPS12010form.ReadFieldButtonClick(Sender: TObject);
var s:string;
begin
    field.value:=ReadField_IPS12010(add);
end;

procedure TIPS12010form.pauseClick(Sender: TObject);
begin
     delay(3);
end;

procedure TIPS12010form.SweeprateButtonClick(Sender: TObject);
begin
     SetSweepRate_IPS12010(add,SweepRate.value);
end;

end.
