unit visupolar;
{petite unit de visualisation de graph en fonction du temps : visualisation de la polarisation
E.Leymarie 10/00}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls,editdata, Spin;

type
  Tvisupol = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    Save: TButton;
    SaveDialog1: TSaveDialog;
    enregistre: TCheckBox;
    nomfich: TEdit;
    Series1: TPointSeries;
    ndernier: TCheckBox;
    dernierp: TSpinEdit;
    Label1: TLabel;
    Clear: TButton;
    Label2: TLabel;
    compteur: TSpinEdit;

    procedure clearvisu;
    procedure ajoute(x,y:real);
    procedure SaveClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);

  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  visupol: Tvisupol;

implementation

{$R *.DFM}

{************************
clear}
procedure tvisupol.clearvisu;

begin
Series1.clear;
compteur.value:=0;
end;

{*********************
ajoute un point
limite le nombre de points
enregistre en parallele dans un fichier}
procedure tvisupol.ajoute(x,y:real);
var f:textfile;
    fich,s:string;
begin

if ndernier.checked then
if Series1.Xvalues.Count>=dernierp.value then
   repeat
   Series1.Xvalues.Delete(0);
   Series1.Yvalues.Delete(0);
   until (Series1.Xvalues.Count=dernierp.value-1);

Series1.AddXY(x,y,'',clred);
compteur.value:=compteur.value+1;

if enregistre.checked then
   begin
   fich:=nomfich.text+'.txt';
   assignfile(f,fich);
   if fexis(fich) then append(f) else rewrite(f);
   s:=floattostr(x)+';'+floattostr(y);
   writeln(f,s);
   closefile(f);
   end;
end;

{***************************************
enregistre la serie au format texte}

procedure Tvisupol.SaveClick(Sender: TObject);
var i:integer;
    f:textfile;
    temp:string;

begin
if savedialog1.execute then
   begin
   AssignFile(f,savedialog1.filename);
   rewrite(f);
   for i:=0 to series1.xvalues.count-1 do
       begin
       temp:=floattostr(series1.xvalues[i])+';'+floattostr(series1.yvalues[i]);
       writeln(f,temp);
       end;
   closefile(f);
   end;
end;
{***************************************
efface les points et le fichier associ}
procedure Tvisupol.ClearClick(Sender: TObject);
var f:textfile;
    fich:string;
begin
clearvisu;
if enregistre.checked then
   begin
   fich:=nomfich.text+'.txt';
   assignfile(f,fich);
   if fexis(fich) then rewrite(f);
   closefile(f);
   end;
end;

end.
