unit CommunicationHadas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

const
     ToHadas = 'ToHadas.txt';
     ToPrims = 'ToPrism.txt';

type
  TForm2 = class(TForm)
    Label1: TLabel;
    CommandFileDirectory: TEdit;
    MeasurementNumber: TSpinEdit;
    Label2: TLabel;
    DataFilename: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Command: TEdit;
    WriteFileButton: TButton;
    ReadFileButton: TButton;
    Label5: TLabel;
    HadasResponse: TEdit;
    procedure WriteFileButtonClick(Sender: TObject);
    procedure ReadFileButtonClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.WriteFileButtonClick(Sender: TObject);
var f:textfile;
begin
    AssignFile(F, CommandFileDirectory.text+'\'+ToHadas);
    {$I-}
    Rewrite(F);
    {$I+}
    if IOResult = 0 then
    begin
      writeln(f,IntToStr(MeasurementNumber.value));
      writeln(f,dataFilename.text);
      writeln(f,command.text);
    end
    else
      MessageDlg('Erreur d''accs au fichier', mtWarning, [mbOk], 0);
end;

procedure TForm2.ReadFileButtonClick(Sender: TObject);
var f:textfile;
begin
    AssignFile(F, CommandFileDirectory.text+'\'+ToPrism);
    {$I-}
    Reset(F);
    {$I+}
    if IOResult = 0 then
    begin
      readln(f,HadasResponse.text);
    end
    else
      MessageDlg('Erreur d''accs au fichier', mtWarning, [mbOk], 0);
end;

end.
