unit MainForm;
{a jour le 30/10/00 }                                                                               
{MODIFICATIONS}
{27.03.01 : EL:modifications pour jumelage avec traitement:
               modification spectre.addspectre(X,Y) en spectre.addspectre(X,Y,1)
               modification data[x,y] en data[x,y,0]
               changement tdeuxdform en tGraph2DForm }
{ 10.12.01 : FO : creation de nouveaux spectres 1D R1Duu et R1Ddd pour acquisition avec multicompteur 1D }
{ ================================== }
{ A FAIRE }
{ * ne crer que les spectres "utiles" pour l'exprience en cours }
{ * transferer cette creation des spectres dans EditData!         }
{ * mettre les bons spectres dans le graph 1D, en particulier pour les PSD 1D }
{ * le programme ne peut pas marcher si l'unit moteurs n'est pas dmarre }
{ => c'est li  l'initialisation de la carte GPIB !!!                     }
{  a faire de manire systmatique                                         }
  
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,editdata,xygraph, Db, Graph2D, Graph1D, DBTables, StdCtrls,
  Spin;
const
wm_fermeture=$400+wm_user;
wm_redessine=$403+wm_user;
wm_reorganiser=$406+wm_user;

type
  Tprincipalform = class(TForm)
    MainMenu1: TMainMenu;
    nouvelle: TMenuItem;
    nouvelle1: TMenuItem;
    N1D1: TMenuItem;
    N1D2: TMenuItem;
    N1: TMenuItem;
    supprimer2: TMenuItem;
    N2: TMenuItem;
    mosaque1: TMenuItem;
    modules1: TMenuItem;
    editiondesmoteurs1: TMenuItem;
    squences1: TMenuItem;
    N3: TMenuItem;
    Ajouter1: TMenuItem;
    Tableseq: TTable;
    DataSourceseq: TDataSource;
    TableseqTitre: TStringField;
    TableseqFichier: TStringField;
    OpenDialog1: TOpenDialog;
    TableseqIndex: TAutoIncField;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    Utiliserlaide1: TMenuItem;
    Rechercher1: TMenuItem;
    Index1: TMenuItem;
    Configurationfentres1: TMenuItem;
    Tablefen: TTable;
    DataSource1: TDataSource;
    TablefenIndex: TAutoIncField;
    TablefenNomfenetre: TStringField;
    TablefenPosX: TIntegerField;
    TablefenPosY: TIntegerField;
    TablefenVisible: TIntegerField;
    TablefenDefautX: TIntegerField;
    TablefenDefautY: TIntegerField;
    TablefenTitre: TStringField;
    TablefenTaillevariable: TIntegerField;
    TablefenWidth: TIntegerField;
    TablefenHeight: TIntegerField;
    sauvegarderconfig1: TMenuItem;
    Main1: TMenuItem;
    procedure nouvelleClick(Sender: TObject);
    procedure supprimer1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N1D1Click(Sender: TObject);
    procedure mosaque1Click(Sender: TObject);
    procedure editiondesmoteurs1Click(Sender: TObject);
    procedure Ajouter1Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
    procedure Configurationfentres1Click(Sender: TObject);
    procedure sauvegarderconfig1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Apropos1Click(Sender: TObject);
  private
    { Dclarations prives}
  protected
    procedure sequenceclick(sender: tobject);
    procedure corrigemenu;
  public
    { Dclarations publiques}
    items:array of tmenuitem;
    procedure redessiner;
    procedure reorganiser;
    procedure wmredessine(var msg:tmessage); message wm_redessine;
  end;

var
  principalform: Tprincipalform;
  gr2d:array[1..4] of tGraph2DForm;
  gr1d:array[1..4] of tgraph1dform;

implementation

uses editMoteursBase, interpreteur, editFenetresBaseParam, about;
{$R *.DFM}

procedure Tprincipalform.nouvelleClick(Sender: TObject);
var
tf:boolean;
i:integer;
begin
tf:=false;
i:=1;
while (not tf) and (i<=4) do begin
if gr2d[i]=nil then begin
 gr2d[i]:=tGraph2DForm.create(self,128,128);
 tf:=true;
end;
i:=i+1;
end;
end;

procedure Tprincipalform.supprimer1Click(Sender: TObject);
var
i:integer;
begin
for i:=1 to 4 do begin
if activemdichild=gr1d[i] then
sendmessage(gr1d[i].handle,wm_fermeture,0,0);{suppression}
if activemdichild=gr2d[i] then
sendmessage(gr2d[i].handle,wm_fermeture,0,0);{suppression}
end;
end;

procedure Tprincipalform.FormCreate(Sender: TObject);
var
ind:integer;
i,j:integer;
begin
tableseq.open;
tablefen.open;
troisd:=spectlist.create;
deuxd:=spectlist.create;
und:=spectlist.Create;
{
******   declaration de ACUP et ACDOWN dans comptage2D
 }
ind:=deuxd.addspectre('ACUP',128,128,1);
deuxd.spect[ind].comment:='spectre upup';
deuxd.spect[ind].typex:='raw';
deuxd.spect[ind].typey:='raw';
for i:=0 to 127 do
for j:=0 to 127 do
deuxd.spect[ind].data[i,j,0].z:=100*exp(-sqr(i-64)/10000)*exp(-sqr(j-64)/10000);
ind:=deuxd.addspectre('ACDOWN',128,128,1);
deuxd.spect[ind].comment:='spectre updown';
deuxd.spect[ind].typex:='raw';
deuxd.spect[ind].typey:='raw';
for i:=0 to 127 do
for j:=0 to 127 do
deuxd.spect[ind].data[i,j,0].z:=40*exp(-sqr(i-128)/10000)*exp(-sqr(j-32)/10000);

{ creation des spectres  une dimension pour les mesures de rflectivit }
ind:=und.addspectre('RUPUP',512,1,1);
und.spect[ind].comment:='rflectivit up-up';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('RDODO',512,1,1);
und.spect[ind].comment:='rflectivit down-down';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('RUPDO',512,1,1);
und.spect[ind].comment:='rflectivit up-down';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('RDOUP',512,1,1);
und.spect[ind].comment:='rflectivit down-up';
und.spect[ind].typex:='reflec';
und.spect[ind].typey:='single';
for i:=0 to 511 do
und.spect[ind].data[i,0,0].z:=1E-5;

{ spectres pour l'aquisition d'une detecteur 1D }
ind:=und.addspectre('R1Duu',512,1,1);
und.spect[ind].comment:='rflectivit up-up';
und.spect[ind].typex:='position';
und.spect[ind].typey:='single';
for i:=0 to 256 do
und.spect[ind].data[i,0,0].z:=1E-5;

ind:=und.addspectre('R1Ddd',512,1,1);
und.spect[ind].comment:='rflectivit down-down';
und.spect[ind].typex:='position';
und.spect[ind].typey:='single';
for i:=0 to 256 do
und.spect[ind].data[i,0,0].z:=1E-5;

WindowState := wsMaximized;
corrigemenu;
end;

procedure Tprincipalform.N1D1Click(Sender: TObject);
var
tf:boolean;
i:integer;
begin
tf:=false;
i:=1;
while (not tf) and (i<=4) do begin
if gr1d[i]=nil then begin
 gr1d[i]:=tgraph1dform.create(self);
 tf:=true;
end;
i:=i+1;
end;
end;

procedure Tprincipalform.mosaque1Click(Sender: TObject);
begin
reorganiser;
end;

procedure Tprincipalform.wmredessine(var msg:tmessage);
begin
redessiner;
end;


procedure Tprincipalform.redessiner;
var
i:integer;
begin
for i := MDIChildCount-1 downto 0 do
sendmessage(mdichildren[i].handle,wm_redessiner,0,0);
end;

procedure Tprincipalform.editiondesmoteurs1Click(Sender: TObject);
begin
editmoteursbaseform.showmodal;
end;

procedure Tprincipalform.Ajouter1Click(Sender: TObject);
var
s:string;
begin
if opendialog1.execute then begin
tableseq.insert;
tableseqfichier.value:=opendialog1.filename;
s:=extractfilename(opendialog1.filename);
tableseqtitre.value:=copy(s,1,pos('.',s)-1);
tableseq.post;
end;
corrigemenu;
end;

procedure Tprincipalform.corrigemenu;
var
i:integer;
begin
for i:=squences1.count downto 3 do squences1.delete(i-1);
for i:=0 to high(items) do items[i].free;
SetLength(items,tableseq.recordcount);
tableseq.first;
i:=0;
while not tableseq.eof do begin
items[i]:=NewItem(tableseqtitre.value,0,false,true
,sequenceclick,0,'');
items[i].tag:=tableseqindex.value;
squences1.add(items[i]);
i:=i+1;tableseq.next;
end;
end;

procedure Tprincipalform.sequenceclick(sender: tobject);
var
i:integer;
begin
for i:=0 to high(items) do
if sender=items[i] then begin
if tableseq.findkey([items[i].tag]) then
interpreteurform.executeseq(tableseqfichier.value);
end;
end;


procedure Tprincipalform.Index1Click(Sender: TObject);
begin
Application.HelpFile := 'c:\help\pilotage.HLP';
Application.HelpCommand(HELP_FINDER, 0);
end;

procedure Tprincipalform.Configurationfentres1Click(Sender: TObject);
begin
editfenetreform.showmodal;
end;

procedure Tprincipalform.reorganiser;
var
i:integer;
begin
for i := MDIChildCount-1 downto 0 do
if tablefen.findkey([mdichildren[i].tag]) then begin
mdichildren[i].top:=tablefenposX.value;
mdichildren[i].left:=tablefenposY.value;
mdichildren[i].width:=tablefenwidth.value;
mdichildren[i].height:=tablefenheight.value;
if tablefenvisible.value=1 then mdichildren[i].windowstate:=wsnormal
else mdichildren[i].windowstate:=wsminimized;
if tablefentaillevariable.value=1 then
mdichildren[i].borderstyle:=bssizeable
else mdichildren[i].borderstyle:=bssingle;
if tablefentitre.value<>'' then mdichildren[i].caption:=tablefentitre.value;
end;
dataeditform.windowstate:=wsminimized;
end;


procedure Tprincipalform.sauvegarderconfig1Click(Sender: TObject);
var
i:integer;
begin
for i := MDIChildCount-1 downto 0 do
if tablefen.findkey([mdichildren[i].tag]) then begin
tablefen.edit;
if mdichildren[i].top<0 then mdichildren[i].top:=0;
if mdichildren[i].left<0 then mdichildren[i].left:=0;
tablefenposX.value:=mdichildren[i].top;
tablefenposY.value:=mdichildren[i].left;
tablefenwidth.value:=mdichildren[i].width;
tablefenheight.value:=mdichildren[i].height;
if mdichildren[i].windowstate=wsnormal then tablefenvisible.value:=1
else tablefenvisible.value:=0;
tablefen.post;
end;
end;

procedure Tprincipalform.FormShow(Sender: TObject);
begin
reorganiser;
end;

procedure Tprincipalform.FormClose(Sender: TObject;
  var Action: TCloseAction);
var ButtonSelected:word;
begin
     ButtonSelected:=MessageDlg('Voulez-vous vraiment quitter le programme de pilotage? Sr sr?',mtConfirmation,[mbNo,mbYes],0);
     if ButtonSelected=mrYes then action:=caFree else begin action:=caNone end;
end;

procedure Tprincipalform.Apropos1Click(Sender: TObject);
begin
  AboutBox.visible:=true;
end;

end.
