unit StabilisationPolar;
{unit destine  stabiliser la polarisation a une valeur donne (essai)
E.Leymarie 17/11/00
MODIFICATIONS :
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls,AT_AOMIO,RMNacquisition,visu_polarisation,ExtCtrls;

type
  Tstabpolform = class(TForm)
    GroupBox1: TGroupBox;
    centrale: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    haute: TEdit;
    Label3: TLabel;
    basse: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    onfin: TEdit;
    Label5: TLabel;
    offfin: TEdit;
    Label6: TLabel;
    onfort: TEdit;
    Label7: TLabel;
    offfort: TEdit;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    periode: TSpinEdit;
    Label9: TLabel;
    integration: TSpinEdit;
    Label10: TLabel;
    sortie: TComboBox;
    atton: TButton;
    attoff: TButton;
    stabButton: TButton;
    StabTimer: TTimer;
    polarType: TComboBox;
    Label11: TLabel;
    GroupBox4: TGroupBox;
    Label12: TLabel;
    editpolar: TEdit;
    Label13: TLabel;
    editpolarmoy: TEdit;
    Label14: TLabel;
    editregul: TEdit;

    procedure  setVout(val:real);
    procedure StabTimerTimer(Sender: TObject);
    procedure stabButtonClick(Sender: TObject);
    procedure attonClick(Sender: TObject);
    procedure attoffClick(Sender: TObject);

  private
    { Dclarations prives}
    polartab:array[1..10] of real; {stock la valeur des dernieres mesures pour moyennage}
    increment:integer;
  public
    { Dclarations publiques}
  end;

var
  stabpolform: Tstabpolform;

implementation

uses RMNbases;

{$R *.DFM}
{******************************}
procedure  Tstabpolform.setVout(val:real);
var ref:string;
begin
ref:=sortie.text;
if ref='Vout1' then
   setVout1(val);
if ref='Vout3' then
   setVout3(val);
if ref='Vout4' then
   setVout4(val);
if ref='Vout5' then
   setVout5(val);
editregul.text:=floattostr(val);
end;
{******************************}

procedure Tstabpolform.StabTimerTimer(Sender: TObject);

var i:integer;
    temps,polar:real;
begin
stabtimer.enabled:=false;
stabtimer.interval:=periode.value*1000;

{mesure de la polar et rangement dans polar tab}
RMNacqui.mesurepolar(RMNacqui.npassage.value,polar,temps);
polartab[increment]:=polar;
increment:=increment+1;
if increment>integration.value then increment:=1; {permet de stocker les integration.value dernieres mesures}
{affichage du point}
visupol.ajoute(temps,polar);
editpolar.text:=floattostr(polar);
{moyennage de la polar sur les integration.value dernieres mesures}
polar:=0;
for i:=1 to integration.value do
    polar:=polar+polartab[i];
polar:=polar/integration.value;
editpolarmoy.text:=floattostr(polar);
{reaction}
if Polartype.text='positive' then
   begin
   if polar>strtofloat(haute.text) then setvout(strtofloat(offfort.text));
   if (polar<=strtofloat(haute.text)) and (polar>strtofloat(centrale.text)) then setvout(strtofloat(offfin.text));
   if (polar<=strtofloat(centrale.text)) and (polar>strtofloat(basse.text)) then setvout(strtofloat(onfin.text));
   if (polar<=strtofloat(basse.text)) then setvout(strtofloat(onfort.text));
   end;
if Polartype.text='negative' then
   begin
   if polar>strtofloat(haute.text) then setvout(strtofloat(onfort.text));
   if (polar<=strtofloat(haute.text)) and (polar>strtofloat(centrale.text)) then setvout(strtofloat(onfin.text));
   if (polar<=strtofloat(centrale.text)) and (polar>strtofloat(basse.text)) then setvout(strtofloat(offfin.text));
   if (polar<=strtofloat(basse.text)) then setvout(strtofloat(offfort.text));
   end;

stabtimer.enabled:=true;
end;
{****************************}
procedure Tstabpolform.stabButtonClick(Sender: TObject);
var freq,amp,niv:real;
    flagpassage:boolean;
begin
flagpassage:=false;
if stabbutton.caption='stabilisation' then
   begin
   freq:=strtofloat(RMNbase.freqacq.text);
   amp:=strtofloat(RMNbase.ampacq.text);
   niv:=strtofloat(RMNbase.nivacq.text);
   {RMNacqui.initacquisition(freq,amp,niv);     }

   visupol.clearvisu;
   increment:=1;

   stabtimer.enabled:=true;
   stabbutton.caption:='STOP stabilisation';
   flagpassage:=true;
   end;
if (stabbutton.caption='STOP stabilisation') and not(flagpassage) then
   begin
   stabtimer.enabled:=false;
   stabbutton.caption:='stabilisation';
   end;

end;
{****************************}
procedure Tstabpolform.attonClick(Sender: TObject);
begin
setvout(strtofloat(onfort.text));
end;
{****************************}

procedure Tstabpolform.attoffClick(Sender: TObject);
begin
setvout(strtofloat(offfort.text));
end;

end.
